//MyComponentFactory.h

#ifndef _MYCOMPONENTFACTORY_H
#define _MYCOMPONENTFACTORY_H

class MyComponent;
class MyEntityManager;

class MyComponentFactory
{
public:
	MyComponentFactory()
	{
	}
	MyComponentFactory( component_uid& uid )
	{
		m_uid = uid;
	}
	MyComponentFactory( const MyComponentFactory& factory )
	{
		m_uid = factory.m_uid;
	}
	virtual ~MyComponentFactory()
	{
	}
	virtual MyComponent* CreateComponent( MyEntity* entity, MyEntityManager* manager )
	{
		return NULL;
	}
	const component_uid& GetUID()
	{
		return m_uid;
	}

protected:
	component_uid m_uid;

};

template<class T>
class MySimpleComponentFactory: public MyComponentFactory
{
public:
	MySimpleComponentFactory( component_uid& uid ) : MyComponentFactory( uid )
	{
	}
	virtual ~MySimpleComponentFactory()
	{
	}
	virtual MyComponent* CreateComponent( MyEntity* entity, MyEntityManager* manager )
	{
		return new T(entity, manager);
	}
};
#endif