//MyEntity.h

#ifndef _MYENTITY_H
#define _MYENTITY_H

#include "MyEntityType.h"
#include "MyEventDispatcher.h"
#include "MyPropertySystem.h"

class MyEntityManager;
class MyComponent;


class MyEntity : public MyPropertySystem, public MyEventDispatcher
{
public:
	MyEntity( MyEntityManager* pManager, entity_uid uid );
	virtual	~MyEntity();
	
	entity_uid		GetUID();
	void			Remove();
	void			Update( int timeDiff );
	void			AddComponent( const component_uid& uid );

	MyComponent*	GetComponent( const component_uid& uid );
	//ٷ ߰, 
	void			DirectDeleteComponent( const component_uid& uid );
	void			DirectSetComponent( const component_uid& uid, MyComponent* pComponent );

protected:
	MyEntityManager*					m_pManager;
	entity_uid							m_uid;

	typedef std::map< const component_uid, MyComponent* >  ComponetTable;
	ComponetTable  m_components;  //йи ID ؼ ϳ ߰ ǵ Ѵ.	

};



inline entity_uid MyEntity::GetUID()
{
	return m_uid;
}
#endif