//MyEntityManager.h
#ifndef _MYENTITYMANAGER_H
#define _MYENTITYMANAGER_H

class MyEntity;
class MyStageManager;
class MyComponentFactory;
class MyComponent;

class MyEntityManager
{
public:
	MyEntityManager( MyStageManager* manager );
	virtual		~MyEntityManager();

	MyStageManager* GetStageManager();
	MyEntity*		CreateEntity( entity_uid uid );
	void			AddEntityToDeleteList( MyEntity* pEntity );
	void			Update( int timeDiff );
	void			RegisterComponent( MyComponentFactory* factory );
	MyComponent*	AddComponentToEntity( component_uid uid, MyEntity* entity );

protected:
	std::list< MyEntity* >		m_entityList;
	std::list< MyEntity* >		m_entityToDelete;
	std::map< component_uid, MyComponentFactory* > m_componentFactory;
	MyStageManager*				m_pStageManager;
};


#endif