//MyEventDispatcher.h

#ifndef _MYEVENTDISPATCHER_H
#define _MYEVENTDISPATCHER_H

#include "MyFunctor.h"

class MyEntity;
class IProperty;

class MyEventDispatcher
{
public:
	MyEventDispatcher();
	virtual	~MyEventDispatcher();
	template<typename T>
	void FireEvent( std::string& name, const T& data, MyEntity* sender )
	{
		if( m_callbacks.find( name ) != m_callbacks.end() )
		{
			MyProperty<T>* p = new MyProperty<T>(name);
			p->GetValue() = data;
			SFunctorContainer2< IProperty*, MyEntity* >* functor2 = m_callbacks.find( name )->second;
			functor2->Call( p, sender );
		}
	}
	template<typename T>
	void RegisterCallback(std::string& name, T* _class, void (T::*func)(IProperty* data, MyEntity* sender))
	{
		if( m_callbacks.find( name ) != m_callbacks.end() )
		{
			SFunctorContainer2< IProperty*, MyEntity* >* value = m_callbacks.find( name )->second;
			value->AddCallback( _class, func );	
			return;
		}

		m_callbacks[ name ] = new SFunctorContainer2< IProperty*, MyEntity* >();
		SFunctorContainer2< IProperty*, MyEntity* >* value = m_callbacks.find( name )->second;
		value->AddCallback( _class, func );
	}
	template<typename T>
	void UnregisterCallback(std::string& name, T* _class )
	{
		if( m_callbacks.find( name ) != m_callbacks.end() )
		{
			SFunctorContainer2< IProperty*, MyEntity* >* value = m_callbacks.find( name )->second;
			value->RemoveCallback( _class );	
		}
	}

protected:
	std::map< std::string, SFunctorContainer2< IProperty*, MyEntity* >* > m_callbacks;
};



#endif