//MyFunctor.h

#ifndef _MYFUNCTOR_H
#define _MYFUNCTOR_H


#include "MyRef.h"

template<typename A, typename B>
class SFunctor2 : public MyRef
{
public:
	SFunctor2()
	{
	}
	virtual ~SFunctor2()  
	{
	}
	virtual void	operator ()(A var1, B var2) = 0;
	virtual void	call( A var1, B var2 ) = 0;
	virtual void*	GetClassPointer() = 0;
};

template<typename T, typename A, typename B>
class SFunctorReciever2 : public SFunctor2<A, B>
{
protected:
	typedef void (T::*funcType)(A, B);
	funcType m_callback;
	T* m_callbackClass;

public:
	SFunctorReciever2(T* callClass, funcType f )
	{
		m_callback = f;
		m_callbackClass = callClass;
	}

	SFunctorReciever2( const SFunctorReciever2& rec )
	{
		m_callback = rec.m_callback;
		m_callbackClass = rec.m_callbackClass;
	}

	void operator ()( A var1, B var2 )
	{
		if( m_callbackClass && m_callback )
		{
			(m_callbackClass->*m_callback)( var1, var2 );
		}
	}

	void call(A var1, B var2)
	{
		if( m_callbackClass && m_callback )
		{
			(m_callbackClass->*m_callback)( var1, var2 );
		}
	}

	void* GetClassPointer()
	{
		return (void*)m_callbackClass;
	}
};


template<typename A, typename B>
class SFunctorContainer2
{
public:
	virtual ~SFunctorContainer2()
	{
		for( unsigned int  i = 0; i < m_callback.size(); ++i )
		{
			m_callback[i]->Dec();
		}
		m_callback.clear();
	}

	template<typename T>
	void AddCallback( T* receiver, void (T::*func)(A, B)  )
	{
		for( unsigned int i = 0; i < m_callback.size(); ++i )
		{
			if( m_callback[i]->GetClassPointer() == (void*)receiver )
				return;
		}
		m_callback.push_back( new SFunctorReciever2< T, A, B >( receiver, func ));		
	}

	template<typename T>
	void RemoveCallback( T* receiver )
	{
		for( unsigned int i = 0; i < m_callback.size(); ++i )
		{
			if( m_callback[i]->GetClassPointer() == (void*)receiver )
			{
				m_callback[i]->Dec();
				m_callback.erase( m_callback.begin() + i );
			}
		}
	}

	void Call(A var1, B var2 )
	{
		for( unsigned int i = 0; i < m_callback.size(); ++i )
		{
			m_callback[i]->call( var1, var2 );
		}
	}

protected:
	std::vector< SFunctor2<A, B>* >  m_callback;
};

#endif