//MyHash.cpp
//GPG 5 1.4 ø ̿ C++ ݿ   ڵ 
#include "stdafx.h"
#include "MyHash.h"

#define INVALID_HASH 0xffffffff
#define HASH_INIT	0x811c9dc5
#define HASH_PRIME	0x01000193
#define CONVERT_BACKSLASH
#define CASE_INSENSITIVE

MyHash::MyHash() : m_hashValue(INVALID_HASH)
{
}

MyHash::MyHash(uint32 hashValue) : m_hashValue(hashValue)
{
}

MyHash::MyHash(const MyHash &rhs) : m_hashValue(rhs.m_hashValue)
{

}

MyHash::MyHash(const char *pString)
{
	m_hashValue = MakeHash(pString);
}

MyHash &MyHash::operator=(const MyHash &rhs)
{
	if (&rhs != this)
	{
		m_hashValue = rhs.m_hashValue;
	}
	return *this;
}

bool MyHash::IsValid() const
{
	return (m_hashValue != INVALID_HASH);
}

uint32 MyHash::MakeHash(const char *hashString)
{
	if (!hashString || !hashString[0])
		return INVALID_HASH;

	const unsigned char* string = (const unsigned char*)hashString;
	uint32 hash = HASH_INIT;

	while (*string)
	{
		hash *= HASH_PRIME;

		char c = *string++;

#ifdef CONVERT_BACKSLASH
		if (c == '\\')
		{
			c = '/';
		}
#endif

#ifdef CASE_INSENSITIVE
		if ((c >= 'a') && (c <= 'z'))
		{
			c -= 'a' - 'A';
		}
#endif
		hash ^= (uint32)c;
	}
	return hash;
}

void MyHash::Set(const uint32 hash)
{
	m_hashValue = hash;
}

const bool MyHash::operator<(const MyHash &rhs) const
{
	return m_hashValue < rhs.m_hashValue;
}

const bool MyHash::operator>(const MyHash &rhs) const
{
	return m_hashValue > rhs.m_hashValue;
}

const bool MyHash::operator<=(const MyHash &rhs) const
{
	return m_hashValue <= rhs.m_hashValue;
}

const bool MyHash::operator>=(const MyHash &rhs) const
{
	return m_hashValue >= rhs.m_hashValue;
}

const bool MyHash::operator==(const MyHash &rhs) const
{
	return m_hashValue == rhs.m_hashValue;
}

const bool MyHash::operator!=(const MyHash &rhs) const
{
	return (!(*this == rhs));
}