//MyPropertySystem.h

#ifndef _MYPROPERTYSYSTEM_H
#define _MYPROPERTYSYSTEM_H

#include "MyProperty.h"


typedef std::list<  IProperty* >	PropertyList;

class MyPropertySystem : public MyRef
{
public:
	virtual ~MyPropertySystem();
protected:
	PropertyList						m_properties;	

public:
	//̽ ø  ν Property ̳ʿ  ִ.
	IProperty*	   GetProperty( const std::string& name );
	template<typename T>
	MyProperty<T>* GetProperty( const std::string& name );
	template<typename T>
	T& GetPropertyValue( const std::string& name );
};


template<typename T>
MyProperty<T>* MyPropertySystem::GetProperty( const std::string& name )
{
	PropertyList::iterator it = m_properties.begin();
	while( it != m_properties.end() )
	{
		if( name.compare((*it)->GetName()) == 0 )
		{
			MyProperty<T>* prop = (MyProperty<T>*)(*it);
			return prop;
		}
		++it;
	}
	MyProperty<T>* prop = new MyProperty<T>( name );
	m_properties.push_back( prop );
	return prop;
}

template<typename T>
inline T& MyPropertySystem::GetPropertyValue( const std::string& name )
{
	PropertyList::iterator it = m_properties.begin();
	while( it != m_properties.end() )
	{
		if( name.compare((*it)->GetName()) == 0 )
		{
			MyProperty<T>* prop = (MyProperty<T>*)(*it);
			return prop->GetValue();
		}
		++it;
	}
	MyProperty<T>* prop = new MyProperty<T>( name );
	m_properties.push_back( prop );
	return prop->GetValue();
}

#endif