//MyStageManager.h

#ifndef _MySTAGEMANAGER_H
#define _MySTAGEMANAGER_H

#include "MyEventDispatcher.h"

class MyStageFactory;
class MyStage;

class MyStageManager : public MyEventDispatcher
{
public:
	MyStageManager();
	virtual ~MyStageManager();

	MyStage*	CreateStage( const std::string& name );
	void		RegisterStage( MyStageFactory* factory );

	bool		Update();

	MyStage*	GetActiveStage()
	{
		return m_mainStage;
	}

public:
	void		AddStage( MyStage* stage );
	void		RemoveStage( MyStage* stage );
	void		StageToRemove( MyStage* stage );

protected:
	std::list< MyStage* >			m_stageColl;
	std::list< MyStage* >			m_stageCollToRemove;
	std::vector< MyStageFactory* >	m_factories;

	MyStage*						m_mainStage;
	float							m_lastTime;

	friend	class					MyStage;
	
};


#endif