//PropertyType.h

#ifndef _PROPERTYTYPE_H
#define _PROPERTYTYPE_H

enum ePropertyType
{
	ept_bool,
	ept_DWORD,
	ept_int,
	ept_float,
	ept_string,
	ept_ptr,
	eptMAX_PROPERTY_TYPES
};

template <class T> class PropertyType
{
public :
	// Returns type ID associated with the templatized type.
	static	ePropertyType	GetTypeID()
	{
		return ms_typeID;
	}
	static	char*			GetTypeName()
	{
		return ms_typeName;
	}

private:
    static	ePropertyType		ms_typeID;
	static  char*				ms_typeName;
};

template<class T> ePropertyType PropertyType<T>::ms_typeID		= ept_ptr;
template<class T> char*			PropertyType<T>::ms_typeName	= "ptr";

template<> ePropertyType PropertyType<bool>::ms_typeID			= ept_bool;
template<> char*		 PropertyType<bool>::ms_typeName		= "bool";

template<> ePropertyType PropertyType<DWORD>::ms_typeID			= ept_DWORD; 
template<> char*		 PropertyType<DWORD>::ms_typeName		= "DWORD"; 

template<> ePropertyType PropertyType<int>::ms_typeID			= ept_int;
template<> char*		 PropertyType<int>::ms_typeName			= "int"; 

template<> ePropertyType PropertyType<float>::ms_typeID			= ept_float; 
template<> char*		 PropertyType<float>::ms_typeName		= "float";

template<> ePropertyType PropertyType<char*>::ms_typeID			= ept_string;
template<> char*		 PropertyType<char*>::ms_typeName		= "string";

#endif	