//healthcomponent.cpp
#include "stdafx.h"

#include "healthcomponent.h"
#include "MyEntityManager.h"
#include "MyStageManager.h"


HealthComponent::HealthComponent( MyEntity* entity, MyEntityManager* manager )
: MyComponent( entity, manager, "DataSheet" ), m_health( GetPropertyValue<int>("Health"))
{
	std::string name = "receiveDamage";
	GetOwner()->RegisterCallback( name, this, &HealthComponent::ReceiveDamage );
}
//--------------------------------------------------------------------------------------------------------
HealthComponent::~HealthComponent()
{
	std::string name = "receiveDamage";
	GetOwner()->UnregisterCallback(name, this );
}
//--------------------------------------------------------------------------------------------------------
void HealthComponent::Update( int timeDiff )
{
	if( m_health <= 0 )
	{
		GetPropertyValue<bool>("Alive") = false;
		std::string name = "EnemyKilled";
		m_pManager->GetStageManager()->FireEvent(name, 20, GetOwner() );
	}
}
//--------------------------------------------------------------------------------------------------------
void HealthComponent::ReceiveDamage( IProperty* property, MyEntity* sender )
{
	MyProperty<int>* p = (MyProperty<int>*)property;
	m_health -= p->GetValue();
}