//player.cpp

#include "stdafx.h"
#include "player.h"
#include "MyStageManager.h"
#include "MyEntityManager.h"
#include "MyProperty.h"

Player::Player( MyStageManager* manager, MyEntityManager* entityManager )
{
	m_pStageManager = manager;
	m_pEntityManager = entityManager;
	m_money = 0;
}
//-----------------------------------------------------------------------------------------
Player::~Player()
{	
	m_pStageManager->UnregisterCallback(std::string("EnemyKilled"), this );
}
//-----------------------------------------------------------------------------------------
void Player::Init()
{
	//register callbacks
	m_pStageManager->RegisterCallback( std::string("EnemyKilled"), this, &Player::EnemyKilled );
}
//-----------------------------------------------------------------------------------------
void Player::EnemyKilled( IProperty* property, MyEntity* sender )
{
	MyProperty<int>* p = (MyProperty<int>*)property;
	m_money += p->GetValue();
}
